package com.jiuqi.dna.ide.designer.commands;

import com.jiuqi.dna.ide.designer.elements.ICompositeElement;
import com.jiuqi.dna.ide.designer.elements.IFigureElement;
import org.eclipse.gef.commands.Command;

/* loaded from: com_jiuqi_dna_ide_designer_commands.jar:com/jiuqi/dna/ide/designer/commands/CompositeMoveChildCommand.class */
public class CompositeMoveChildCommand extends Command {
    private ICompositeElement parent;
    private IFigureElement child;
    private IFigureElement after;
    private int index;

    public CompositeMoveChildCommand(IFigureElement child, IFigureElement after) {
        this.parent = child.getParent();
        this.child = child;
        this.after = after;
        this.index = this.parent.getChildIndex(child);
    }

    public boolean canExecute() {
        return this.child != this.after;
    }

    public void execute() {
        this.parent.removeChild(this.child);
        int idx = this.parent.getChildIndex(this.after);
        if (idx != -1) {
            this.parent.addChild(idx, this.child);
        } else {
            this.parent.addChild(this.child);
        }
    }

    public void undo() {
        this.parent.removeChild(this.child);
        if (this.index != -1) {
            this.parent.addChild(this.index, this.child);
        } else {
            this.parent.addChild(this.child);
        }
    }
}
